\name{gpHist-package}
\alias{gpHist-package}
\docType{package}
\title{
Gaussian process with histogram intersection kernel
}
\description{
This package provide an implementation of a Gaussian process regression using a histogram intersection kernel an utilizes approximations for the approximation of the log-likelihood and variance prediction.
The number of estimated eigenvectors can be selected. This package i build to be light weight and fast execution time.

}
\details{
\tabular{ll}{
Package: \tab gpHist\cr
Type: \tab Package\cr
Version: \tab 0.1\cr
Date: \tab 2017-09-21\cr
License: \tab GPL\cr
LazyLoad: \tab yes\cr
}

This package only provides a limited amount of functions. 
The function gpHist is utilized to estimate the Gaussian process wit a limited number of estimated eigenvectors.
Prediction of a new sample mean can be done with the gpHistPredict function, and an approximation of the prediction variance can be obtained from the gpHistVariance function.
If estimation of the hyperparameters is required, the package provides and function that utilizes the downhillsimplex method for estimation of the hyperparameters.


}
\author{

Maintainer: Dennis Becker <dbecker@leuphana.de>

}

\references{
The utilized approximations are described in the following paper:

Rodner, E., Freytag, A., Bodesheim, P., Froehlich, B., & Denzler, J. (2016). Large-Scale Gaussian Process Inference with Generalized Histogram Intersection Kernels for Visual Recognition Tasks. International Journal of Computer Vision, pp. 1-28. Springer US. doi:10.1007/s11263-016-0929-y


}
\keyword{ package }

\seealso{
Function for estimation of the GP:
\code{\link[gpHist:gpHist]{gpHist}}

Function for prediction of new samples: 
\code{\link[gpHist:gpHistPredict]{gpHistPredict}}

Function for prediction of new sample variance:
\code{\link[gpHist:gpHistVariance]{gpHistVariance}}

Function for hyperparameter estimation:
\code{\link[gpHist:estimateHyperParameters]{estimateHyperParameters}}

}

